(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: TXTCAP.PAS                                                     *)
(*  Obsah: rezidentni program na ukladani textovych obrazovek              *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 25.7.2020                                             *)
(*  Pro kompilaci: (DOS.TPU)                                               *)
(*  Pro spusteni: musite byt v cistem Dosu, pod Windows nefunguje          *)
(*                vytvari soubor C:\TXTCAP.$$$                             *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(*              POZOR: tenhle muze byt opravdu nebezpecny!                 *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
{$M 2000,0,0} {pro rezidentni program je omezeni pameti nutne, jinak by si pro sebe zabral vsechnu}
program TextoveScreenshotovadlo;
{$I-}
uses dos;

const KapacitaPameti=30;

type TextovaObrazovka=array[1..25,1..80]
                        of record
                           znak:char;
                           atribut:byte;
                           end;
     ObrazovkaBezBarev=array[1..25,1..80] of char; {totez, ale bez atributu}

var SkutecnaObrazovka:textovaobrazovka absolute $B800:0; {adresa fyzicke obrazovky (VRAM)}
    UlozeneObrazovky:array[1..kapacitapameti] of obrazovkabezbarev;
    PocetUlozenychObrazovek:word;
    PuvodniInt9,PuvodniInt1Ch:procedure;
    PocitadloPiskani,
    rozsirena:byte;

function PripravUloziste:boolean; {ulozi adresu uloziste v pameti do souboru, aby si ji ukladaci program mohl precist}
var f:file of pointer;
    p:pointer;
Begin
pocetulozenychobrazovek:=0;
fillchar(ulozeneobrazovky,sizeof(ulozeneobrazovky),' ');
assign(f,'C:\TXTCAP.$$$');
rewrite(f);
p:=addr(pocetulozenychobrazovek);
write(f,p);
p:=addr(ulozeneobrazovky);
write(f,p);
close(f);
pripravuloziste:=ioresult=0;
End;{pripravuloziste}

procedure Sound(hz:word); assembler; {zapne piskani o dane frekvenci}
Asm
mov bx,hz
mov ax,34ddh
mov dx,0012h
cmp dx,bx
jnc @2
 div bx
 mov bx,ax
 in al,61h
 test al,3
 jnz @1
  or al,3
  out 61h,al
  mov al,0b6h
  out 43h,al
 @1:
 mov al,bl
 out 42h,al
 mov al,bh
 out 42h,al
@2:
End;{sound}

procedure NoSound; assembler; {vypne piskani}
Asm
in al,61h
and al,0fch
out 61h,al
End;{nosound}

procedure MojeInt1Ch; interrupt; {nova obsluha casovace - ridi zvukove signaly}
Begin
if pocitadlopiskani<>0 then begin
                            dec(pocitadlopiskani);
                            if pocitadlopiskani=0 then nosound;
                            end;
asm pushf end; {PuvodniInt1Ch je preruseni, takze konci instrukci iret, ktera dela popf}
puvodniint1ch;
port[$20]:=$20; {nezbytny reset radice preruseni}
End;{mojeint1ch}

procedure MojeInt9; interrupt; {nova obsluha klavesnice - pri stisku Printscreenu uklada obrazovku do pameti}
const MaxScanKod=93;
      pPrintScreen=55+maxscankod;
var scankod,scankod2:byte;
    stisknuto:boolean;
    i,j:byte;
Begin
scankod:=port[$60];
if scankod=224 {signal rozsirene klavesy}
  then rozsirena:=maxscankod
  else begin
       stisknuto:=scankod and $80=0; {nejvyssi bit rozlisuje stisk od pusteni}
       scankod2:=scankod and $7F+rozsirena; {Scankod2 je rozsireny a bez horniho bitu}
       rozsirena:=0;
       if stisknuto and (scankod2=pprintscreen)
         then if pocetulozenychobrazovek<kapacitapameti
                then begin
                     inc(pocetulozenychobrazovek);
                     for i:=1 to 25 do
                      for j:=1 to 80 do ulozeneobrazovky[pocetulozenychobrazovek,i,j]:=skutecnaobrazovka[i,j].znak;
                     sound(1000); {vysoke kratke pipnuti: OK}
                     pocitadlopiskani:=2;
                     end
                else begin
                     sound(500); {nizsi delsi pipnuti: dosla pamet}
                     pocitadlopiskani:=10;
                     end;
       end;
if scankod2=pprintscreen {printscreen je potreba sezrat, aby neprosel dal do systemu a nespustil tisk na tiskarne}
  then port[$20]:=$20 {reset radice preruseni}
  else begin
       asm pushf end;
       puvodniint9;  {puvodni obsluha klavesnice}
       end;
End;{mojeint9}

BEGIN
if not pripravuloziste
  then begin
       writeln('Chyba: nepodarilo se vytvorit soubor TXTCAP.$$$.');
       halt;
       end;
rozsirena:=0;
pocitadlopiskani:=0;
getintvec($1C,@puvodniint1ch);
getintvec(9,@puvodniint9);
setintvec($1C,@mojeint1ch);
setintvec(9,@mojeint9);
writeln('Rezidentni program TXTCAP.EXE je nahrany v pameti a ceka na povely.');
writeln('Pro vyfoceni obrazovky stisknete Printscreen,');
writeln('uspech je signalizovan kratkym vysokym pipnutim.');
writeln('Kapacita pameti je 30 obrazovek,');
writeln('pri jejim prekroceni se ozve delsi a hlubsi pipnuti.');
writeln('Pro ulozeni vyfocenych obrazovek do souboru pouzijte program TXTSAV.EXE.');
writeln('Pro ukonceni rezidentniho programu nebo pro vymazani pameti obrazovek');
writeln('restartujte pocitac. Nespoustejte TXTCAP podruhe!');
keep(0);
END.
